# Generated by Django 3.2.4 on 2021-06-28 15:35

import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import timezone_field.fields


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Instrument',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('symbol', models.CharField(max_length=10)),
                ('name', models.CharField(blank=True, max_length=300, null=True)),
                ('exchange', models.CharField(blank=True, max_length=20, null=True)),
                ('currency', models.CharField(max_length=20)),
                ('timezone', timezone_field.fields.TimeZoneField(blank=True, null=True)),
                ('category', models.CharField(blank=True, max_length=100, null=True)),
            ],
            options={
                'ordering': ['symbol'],
                'unique_together': {('symbol', 'exchange')},
            },
        ),
        migrations.CreateModel(
            name='Bar',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('timestamp', models.IntegerField()),
                ('resolution', models.CharField(max_length=3, validators=[django.core.validators.RegexValidator('^\\d{0,2}[smHDWMY]$')])),
                ('open', models.FloatField()),
                ('low', models.FloatField()),
                ('high', models.FloatField()),
                ('close', models.FloatField()),
                ('volume', models.BigIntegerField()),
                ('instrument', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='bars', to='candlestick.instrument')),
            ],
            options={
                'ordering': ['timestamp'],
            },
        ),
    ]
